import { ChannelManager } from '../channel';
import { NPMExecutor } from '../npm';
import { PluginManager, PluginMetaLoader } from '../plugin';
import { RepositoryManager } from '../plugin/repository';
import { Configuration, IEnvironment } from '../types';
import { ScopedEventEmitter } from '../util';

/**
 * Reference of a fully featured Squeebot core.
 * Recommended implementation of a squeebot runner implements this interface.
 */
export interface ISqueebotCore {
  environment: IEnvironment;
  npm: NPMExecutor;
  stream: ScopedEventEmitter;
  pluginManager: PluginManager;
  repositoryManager: RepositoryManager;
  channelManager: ChannelManager;
  pluginLoader: PluginMetaLoader;
  config: Configuration;

  initialize(autostart: boolean): Promise<void>;
  shutdown(): void;
}
